var loginCheck, inboxLoadCheck, mailCheck, msgCheck;
var USER_INFO;
function NEW_USER_INFO(){
	var userNfo = {
		USERNAME : null,
		PASSWORD : null
	};
	return userNfo;
}
var LOGGED_IN = new Boolean();
var LOGIN_ERROR = new Boolean();
var LOADED_INBOX = new Boolean();
var LOADED_MSG = new Boolean();
var MESSAGE_CONTENT;
var MESSAGE_ID;
var SHOW_INBOX = new Boolean();
var SHOW_COMPOSE = new Boolean();
var COMPOSE_TYPE;
var newMessages;
function newNewMessages(){
	var nm = null;
	return nm;
}
var MESSAGE_VAULT;
function NEW_MESSAGE_VAULT(){
	var MV = new Array();
	return MV;
}
var INBOX_NFO;
function INBOX_INFO(){
	var InNfo = {
		SHOW_START : null,
		SHOW_END : null,
		TOTAL_COUNT : null
	};
	return InNfo;
}
function newMsgHeader(){
	var MESSAGE_HEADER = {
		MSG_ID : null,
		MSG_FLAG : null,
		MSG_FROM : null,
		MSG_TITLE : null,
		MSG_DATE : null,
		MSG_SIZE : null
	};
	return MESSAGE_HEADER;
}

function init(){
	System.Gadget.settingsUI = 'settings.html';
	
	LOGGED_IN = false;
	if(loadSettings()){
		testLoginInfo();
	}
}

function testLoginInfo(){
	if((USER_INFO.USERNAME == '') || (USER_INFO.PASSWORD == '')){		
		document.getElementById('loginInfo').innerHTML = 'Go to settings to enter login info.';
		setDisplayType(2);
	}else{			
		LOGIN_ERROR = false;
		doLogin(USER_INFO.USERNAME, USER_INFO.PASSWORD);
		loginCheck = setInterval("checkLogin()", 100);
	}
}

System.Gadget.onSettingsClosed = function(event){	
	if (event.closeAction == event.Action.commit){
		setDisplayType(0);
		testLoginInfo();		
	}
}

function setDisplayType(dType){
	switch(dType){
		case 0:
			document.getElementById('menu').style.visibility = 'hidden';
			document.getElementById('new_mail_info').style.visibility = 'hidden';
			document.getElementById('loginInfo').style.visibility = 'hidden';			
			break;
		case 1:
			document.getElementById('menu').style.visibility = 'visible';
			document.getElementById('loginInfo').style.visibility = 'hidden';
			break;
		case 2:
			document.getElementById('menu').style.visibility = 'hidden';
			document.getElementById('new_mail_info').style.visibility = 'hidden';
			document.getElementById('loginInfo').style.visibility = 'visible';			
			break;
	}
}

function checkLogin(){
	if(LOGGED_IN){
		setDisplayType(1);
		//Start mail checking
		checkMail();
		mailCheck = setInterval("checkMail()", 30000);
		clearInterval(loginCheck);
	}else if(!LOGGED_IN){
		if(LOGIN_ERROR){
			document.getElementById('loginInfo').innerHTML = 'Login error!!';
		}else{
			document.getElementById('loginInfo').innerHTML = 'Connecting...';
		}
		setDisplayType(2);		
	}else{
		setDisplayType(0);
	}
}

function checkMail(){
	if(LOGGED_IN){
		LOADED_INBOX = false;
		getInbox('http://mail01.mail.com/scripts/mail/mailbox.mail?read=yes&folder=INBOX&order=Newest&mview=a&mstart=1');
		inboxLoadCheck = setInterval("isInboxLoaded()", 100);
	}else{
		clearInterval(mailCheck);
		clearInterval(loginCheck);
		clearInterval(inboxLoadCheck);		
		LOGIN_ERROR = false;		
		doLogin(USER_INFO.USERNAME, USER_INFO.PASSWORD);
		loginCheck = setInterval("checkLogin()", 100);
	}
}

function isInboxLoaded(){
	if(LOADED_INBOX){
		if(newMessages > 0){
			document.getElementById('new_mail_info').style.visibility = 'visible';
			document.getElementById('new_mail_info').innerHTML = newMessages;
		}else{
			document.getElementById('new_mail_info').style.visibility = 'hidden';
			document.getElementById('new_mail_info').innerHTML = '';
		}
		clearInterval(inboxLoadCheck);
	}
}

function loadSettings(){
	var reg = new RegistryObj();
	USER_INFO = NEW_USER_INFO();
	if(reg.readStringValue("username") != null){
		USER_INFO.USERNAME = reg.readStringValue("username");
	}else{
		USER_INFO.USERNAME = '';
	}
	if(reg.readStringValue("password") != null){
		USER_INFO.PASSWORD = reg.readStringValue("password");
	}else{
		USER_INFO.PASSWORD = '';
	}
	return true;
}

function doLogin(username, password){
	var requestStr = 'Text1=' + username + '&login=' + username + '&password1=' + password + '&password=' + password + '&redirlogin=0&siteselected=normal';	
	xml_request = new XMLHttpRequest();
	xml_request.onreadystatechange = function() {
	    if(xml_request.readyState == 4){
			if((xml_request.responseText.indexOf('err_serverconnect_fail') == -1) && (xml_request.status == 200)){
				LOGGED_IN = true;				
				//document.getElementById('apDiv1').style.visibility = 'visible';	
			}else{
				LOGGED_IN = false;
				LOGIN_ERROR = true;
				//document.getElementById('apDiv1').style.visibility = 'visible';
				//document.getElementById('apDiv1').innerHTML = 'ERROR!';
			}
		}
	}
	xml_request.open("POST", "http://www2.mail.com/scripts/common/proxy.main?signin=1&amp;lang=us", true);
	xml_request.setRequestHeader("Cache-Control", "no-cache");
	xml_request.setRequestHeader('Content-type','application/x-www-form-urlencoded');
	xml_request.send(requestStr);
	//alert(xml_request.responseXML.url);
}

function getInbox(url){
	xml_inbox = new XMLHttpRequest();
	xml_inbox.onreadystatechange = function() {
	    if(xml_inbox.readyState == 4){
			var inbox_doc = xml_inbox.responseText;
			MESSAGE_VAULT = new NEW_MESSAGE_VAULT();
			getInboxInfo(inbox_doc);
			getInboxRows(inbox_doc);
			newMessages = new newNewMessages();
			newMessages = 0;
			for(var i = 0; i < MESSAGE_VAULT.length; i++){
				if(MESSAGE_VAULT[i].MSG_FLAG == 1){
					newMessages += 1;
				}
			}
			LOADED_INBOX = true;
			//alert(newMessages);
			//alert('Showing ' + INBOX_NFO.SHOW_START + '-' + INBOX_NFO.SHOW_END + ' [' + INBOX_NFO.TOTAL_COUNT + ']');
		}
	}
	xml_inbox.open("POST", url, true);
	xml_inbox.send(null);
}

function getInboxInfo(inbox_txt){
	var partStr, nfoArray;
	INBOX_NFO = new INBOX_INFO();
	partStr = inbox_txt.substr(inbox_txt.indexOf('<td align="right" class="fl">'));
	partStr = partStr.substring(partStr.indexOf('Showing') + 7, partStr.indexOf('| <a') - 21);
	partStr = partStr.toLowerCase();
	var pattern = new RegExp(/ /g);
	partStr = partStr.replace(pattern, '');
	var pattern = new RegExp(/<b>/g);
	partStr = partStr.replace(pattern, '');
	var pattern = new RegExp(/to/g);
	partStr = partStr.replace(pattern, '');
	var pattern = new RegExp(/of/g);
	partStr = partStr.replace(pattern, '');
	var pattern = new RegExp(/<\/b>/g);
	partStr = partStr.replace(pattern, '|');
	nfoArray = new Array();
	nfoArray = partStr.split('|');
	INBOX_NFO.SHOW_START = parseInt(nfoArray[0]);
	INBOX_NFO.SHOW_END = parseInt(nfoArray[1]);
	INBOX_NFO.TOTAL_COUNT = parseInt(nfoArray[2]);
}

function getInboxRows(inbox_txt){
	var partStr, LCpartStr, msgHeaderStr, headArray;
	var searchPattern = new RegExp(/<tr.*class="ir"/g);
	partStr = inbox_txt.substr(inbox_txt.search(searchPattern));
	LCpartStr = partStr.toLowerCase();
	//document.getElementById('inbox').innerHTML = LCpartStr;
	while(LCpartStr.search(searchPattern) != -1){
		msgHeaderStr = partStr.substring(LCpartStr.search(/<td/i), LCpartStr.search(/<\/tr>/i) + 5);		
		var tmpMsgHead = new newMsgHeader();
		headArray = msgHeaderStr.split(/<\/td>/i);
		tmpMsgHead.MSG_FROM = headArray[0];
		tmpMsgHead.MSG_TITLE = headArray[1];
		tmpMsgHead.MSG_DATE = headArray[2];
		tmpMsgHead.MSG_SIZE = headArray[3];
		if(tmpMsgHead.MSG_FROM.search(/<B>/i) != -1){
			tmpMsgHead.MSG_FLAG = 1;
		}else{
			tmpMsgHead.MSG_FLAG = 0;
		}
		tmpMsgHead.MSG_ID = returnMSG_ID(tmpMsgHead.MSG_TITLE);
		tmpMsgHead = cleanMsgStrings(tmpMsgHead);
		
		MESSAGE_VAULT.push(tmpMsgHead);
		
		partStr = partStr.substr(partStr.indexOf('</tr>') + 5);
		LCpartStr = partStr.toLowerCase();
	}
}

function returnMSG_ID(msgTitleStr){
	var msgID;
	msgID = msgTitleStr.substr(msgTitleStr.indexOf('msg_uid=') + 8);
	msgID = msgID.substr(0, msgID.indexOf('&'));
	return parseInt(msgID);
}

function cleanMsgStrings(msgHead){
	var pattern = new RegExp(/<td.*?>/g);
	msgHead.MSG_FROM = msgHead.MSG_FROM.replace(pattern, '');
	msgHead.MSG_TITLE = msgHead.MSG_TITLE.replace(pattern, '');
	msgHead.MSG_DATE = msgHead.MSG_DATE.replace(pattern, '');
	msgHead.MSG_SIZE = msgHead.MSG_SIZE.replace(pattern, '');
	pattern = /<\/td>/g;
	msgHead.MSG_FROM = msgHead.MSG_FROM.replace(pattern, '');
	msgHead.MSG_TITLE = msgHead.MSG_TITLE.replace(pattern, '');
	msgHead.MSG_DATE = msgHead.MSG_DATE.replace(pattern, '');
	msgHead.MSG_SIZE = msgHead.MSG_SIZE.replace(pattern, '');
	pattern = /<a.*?>/g;
	msgHead.MSG_TITLE = msgHead.MSG_TITLE.replace(pattern, '');
	pattern = /<\/a>/g;
	msgHead.MSG_TITLE = msgHead.MSG_TITLE.replace(pattern, '');
	pattern = /<b>/g;
	msgHead.MSG_FROM = msgHead.MSG_FROM.replace(pattern, '');
	msgHead.MSG_TITLE = msgHead.MSG_TITLE.replace(pattern, '');
	pattern = /<\/b>/g;
	msgHead.MSG_FROM = msgHead.MSG_FROM.replace(pattern, '');
	msgHead.MSG_TITLE = msgHead.MSG_TITLE.replace(pattern, '');
	pattern = /<B>/g;
	msgHead.MSG_FROM = msgHead.MSG_FROM.replace(pattern, '');
	msgHead.MSG_TITLE = msgHead.MSG_TITLE.replace(pattern, '');
	pattern = /<\/B>/g;
	msgHead.MSG_FROM = msgHead.MSG_FROM.replace(pattern, '');
	msgHead.MSG_TITLE = msgHead.MSG_TITLE.replace(pattern, '');
	pattern = /<div.*?>/g;
	msgHead.MSG_FROM = msgHead.MSG_FROM.replace(pattern, '');
	pattern = /<\/div>/g;
	msgHead.MSG_FROM = msgHead.MSG_FROM.replace(pattern, '');
	pattern = /^\s+|\s+$/g;
	msgHead.MSG_FROM = msgHead.MSG_FROM.replace(pattern, '');
	msgHead.MSG_TITLE = msgHead.MSG_TITLE.replace(pattern, '');
	msgHead.MSG_DATE = msgHead.MSG_DATE.replace(pattern, '');
	msgHead.MSG_SIZE = msgHead.MSG_SIZE.replace(pattern, '');
	return msgHead;
}

function showInbox(){
	SHOW_INBOX = true;
	System.Gadget.Flyout.file = 'inbox.html';
	System.Gadget.Flyout.show = true;
}

function showCompose(cType){
	SHOW_COMPOSE = true;
	COMPOSE_TYPE = cType;
	System.Gadget.Flyout.file = 'compose.html';
	System.Gadget.Flyout.show = true;
}

System.Gadget.Flyout.onShow = function(){
	var GADGET_WND = System.Gadget.document.parentWindow;
	var FLYOUT_DOC = System.Gadget.Flyout.document;
	if(System.Gadget.Sidebar.dockSide == 'Left'){
		FLYOUT_DOC.getElementById('closeBtnImg').src = 'images/left_arrows.png';
	}
	if(GADGET_WND.SHOW_INBOX){
		
	}
	if(GADGET_WND.SHOW_COMPOSE){		
		
	}
}

function checkRFmsg(){
	var GADGET_WND = System.Gadget.document.parentWindow;
	var FLYOUT_DOC = System.Gadget.Flyout.document;
	if(GADGET_WND.LOADED_MSG){		
		var fromAdr = GADGET_WND.MESSAGE_CONTENT.substring(GADGET_WND.MESSAGE_CONTENT.search(/&#34;/g), GADGET_WND.MESSAGE_CONTENT.search(/<br>/i));
		fromAdr = fromAdr.replace(/&#34;/g, '"');
		fromAdr = fromAdr.replace(/&lt;/g, '<');
		fromAdr = fromAdr.replace(/&gt;/g, '>');
		var msgSubject = GADGET_WND.MESSAGE_CONTENT.substr(GADGET_WND.MESSAGE_CONTENT.search(/Subject:/g) + 8);
		msgSubject = msgSubject.substring(msgSubject.search(/<\/b>/i) + 4, msgSubject.search(/<br>/i));
		msgSubject = msgSubject.replace(/^\s+|\s+$/g, '');
		var plainTextMsg = GADGET_WND.MESSAGE_CONTENT.substr(GADGET_WND.MESSAGE_CONTENT.search(/<\/table>/) + 8);
		plainTextMsg = plainTextMsg.replace(/<([^>]+)>/g, '');
		plainTextMsg = plainTextMsg.replace(/&#34;/g, '"');
		plainTextMsg = plainTextMsg.replace(/&lt;/g, '<');
		plainTextMsg = plainTextMsg.replace(/&gt;/g, '>');		
		
		if(GADGET_WND.COMPOSE_TYPE == 1){			
			FLYOUT_DOC.getElementById('to').value = fromAdr;
			FLYOUT_DOC.getElementById('subject').value = 'RE: ' + msgSubject;
			FLYOUT_DOC.getElementById('body').value = '\n\n\n\n----- Original Message -----\n' + plainTextMsg;
			FLYOUT_DOC.getElementById('isreply').value = GADGET_WND.MESSAGE_ID;
		}else if(GADGET_WND.COMPOSE_TYPE == 2){			
			FLYOUT_DOC.getElementById('subject').value = 'FW: ' + msgSubject;
			FLYOUT_DOC.getElementById('body').value = '\n\n\n\n----- Original Message -----\n' + plainTextMsg;
			FLYOUT_DOC.getElementById('isforward').value = GADGET_WND.MESSAGE_ID;
		}
	}
}

function generateInbox(){
	var GADGET_WND = System.Gadget.document.parentWindow;
	var FLYOUT_DOC = System.Gadget.Flyout.document;
	FLYOUT_DOC.getElementById('inboxInfo').innerHTML = 'Showing ' + GADGET_WND.INBOX_NFO.SHOW_START + ' to ' + GADGET_WND.INBOX_NFO.SHOW_END + ' of ' + GADGET_WND.INBOX_NFO.TOTAL_COUNT;
	var messageTable = '<table width="518" border="0" cellspacing="0" cellpadding="1">' +
    						'<tr id="mailHeader_header">' +
      							'<td width="16" height="16" valign="middle">&nbsp;</td>' +
      							'<td width="140" valign="middle" class="headerCell">From</td>' +
      							'<td width="222" valign="middle" class="headerCell">Subject</td>' +
      							'<td width="100" valign="middle" class="headerCell">Date</td>' +
      							'<td width="30" align="center" valign="middle" class="headerCell">Size</td>' +
    						'</tr>';
	for(var i = 0; i < GADGET_WND.MESSAGE_VAULT.length; i++){
    	var newStart, newEnd;
		if(GADGET_WND.MESSAGE_VAULT[i].MSG_FLAG == 1){
			newStart = '<b>';
			newEnd = '</b>';
		}else{
			newStart = '';
			newEnd = '';
		}
		messageTable += '<tr class="msg_item" id="mailHeader_item_' + GADGET_WND.MESSAGE_VAULT[i].MSG_ID + '" onclick="showMessage(' + GADGET_WND.MESSAGE_VAULT[i].MSG_ID + ')" onmouseover="MM_changeProp(\'mailHeader_item_' + GADGET_WND.MESSAGE_VAULT[i].MSG_ID + '\',\'\',\'backgroundColor\',\'#ffdcff\',\'TR\')" onmouseout="MM_changeProp(\'mailHeader_item_' + GADGET_WND.MESSAGE_VAULT[i].MSG_ID + '\',\'\',\'backgroundColor\',\'#FFFFFF\',\'TR\')">' +
      							'<td width="16" height="16" valign="middle">&nbsp;</td>';
      	if(GADGET_WND.MESSAGE_VAULT[i].MSG_FROM.length > 22){
			messageTable += '<td valign="middle" class="itemCell" title="' + GADGET_WND.MESSAGE_VAULT[i].MSG_FROM + '">' + newStart + GADGET_WND.MESSAGE_VAULT[i].MSG_FROM.substr(0, 18) + '...' + newEnd + '</td>';
		}else{
			messageTable += '<td valign="middle" class="itemCell" title="' + GADGET_WND.MESSAGE_VAULT[i].MSG_FROM + '">' + newStart + GADGET_WND.MESSAGE_VAULT[i].MSG_FROM + newEnd + '</td>';
		}
      	if(GADGET_WND.MESSAGE_VAULT[i].MSG_TITLE.length > 30){
			messageTable += '<td valign="middle" class="itemCell" title="' + GADGET_WND.MESSAGE_VAULT[i].MSG_TITLE + '">' + newStart + GADGET_WND.MESSAGE_VAULT[i].MSG_TITLE.substr(0, 29) + '...' + newEnd + '</td>';
		}else{
			messageTable += '<td valign="middle" class="itemCell" title="' + GADGET_WND.MESSAGE_VAULT[i].MSG_TITLE + '">' + newStart + GADGET_WND.MESSAGE_VAULT[i].MSG_TITLE + newEnd + '</td>';
		}
      	messageTable += '<td align="center" valign="middle" class="itemCell">' + newStart + GADGET_WND.MESSAGE_VAULT[i].MSG_DATE + newEnd + '</td>' +
      						'<td align="center" valign="middle" class="itemCell">' + newStart + GADGET_WND.MESSAGE_VAULT[i].MSG_SIZE + newEnd + '</td>' +
    					'</tr>';
	}
    messageTable += '<tr>' +
      					'<td height="16" colspan="5" valign="middle" id="messageTools">&nbsp;</td>' +
    				'</tr>' +
  					'</table>';
	FLYOUT_DOC.getElementById('mailHeaders').innerHTML = messageTable;
}

function loadMsg(msg_id){
	var GADGET_WND = System.Gadget.document.parentWindow;
	GADGET_WND.LOADED_MSG = false;
	getMsgContent(msg_id);
	msgCheck = setInterval("checkLoadMsg()", 100);
}

function checkLoadMsg(){
	var GADGET_WND = System.Gadget.document.parentWindow;
	if(GADGET_WND.LOADED_MSG){
		System.Gadget.Flyout.document.getElementById('mailPreview').innerHTML = GADGET_WND.MESSAGE_CONTENT;
		clearInterval(msgCheck);
	}
}

function getMsgContent(msg_id){
	var GADGET_WND = System.Gadget.document.parentWindow;
	xml_msg = new XMLHttpRequest();
	xml_msg.onreadystatechange = function() {
	    if(xml_msg.readyState == 4){
			if(xml_msg.status == 200){
				var msgBody = xml_msg.responseText;
				var startPattern = new RegExp(/<body.*?>/i);
				var endPattern = new RegExp(/<!-- ml_print_footer.htm -->/g);
				msgBody = msgBody.substring(msgBody.search(startPattern), msgBody.search(endPattern));
				msgBody = msgBody.substr(msgBody.indexOf('>') + 1);
				
				msgBody = '<table width="200" border="0" cellpadding="0" cellspacing="2" id="mailBtns">' +
    						'<tr>' +
      							'<td width="46"><a href="JavaScript:reply(' + msg_id + ');">Reply</a></td>' +
      							'<td width="154"><a href="JavaScript:forwardMsg(' + msg_id + ');">Forward</a></td>' +
    						'</tr>' +
  						  '</table>' + msgBody;
				 GADGET_WND.MESSAGE_CONTENT = msgBody;
				 GADGET_WND.LOADED_MSG = true;
			}else{
				GADGET_WND.MESSAGE_CONTENT = 'Error reading the message from the server!';
				GADGET_WND.LOADED_MSG = true;
			}			
		}
	}
	xml_msg.open("GET", 'http://mail01.mail.com/scripts/mail/read.mail?print=1&folder=INBOX&pbox=1&mhead=b&msg_uid=' + msg_id, true);
	xml_msg.send(null);
}

System.Gadget.Flyout.onHide = function(){
	var GADGET_WND = System.Gadget.document.parentWindow;
	GADGET_WND.SHOW_INBOX = false;
	GADGET_WND.SHOW_COMPOSE = false;
}